<?php
# a simple solitaire
# written in PHP
# copyright 2004 by ninux <antonio.bonifati@virgilio.it>
# licensed under GNU GPL (for details see COPYING)
# web site: http://queen.rett.polimi.it/~ant
#
# this program is lynx and links friendly!
#
# cards were taken from http://www.waste.org/~oxymoron/cards/
# and are also covered by GPL
#
# this program needs
# PHP 4 >= 4.1.0

require('conf.php');    # cards' pack configuration

function legal_move($i, $j)
{ global $v;
  return $_SESSION['t'] && $j==array_search($_SESSION['st'][$_SESSION['t']-1][0], $v) &&
    (($sr=array_search($_SESSION['st'][$_SESSION['t']-1][1], $_SESSION['rs']))===$i
      || $sr===FALSE && !isset($_SESSION['rs'][$i]));
}

function won()
{ global $v;
  for ($i=0; $i<4; $i++)
    for ($j=0; $j<10; $j++)
    { $p=$i*10+$j;
      if (array_search($_SESSION['c'][$p][0], $v)!=$j || $_SESSION['c'][$p][1]!=$_SESSION['rs'][$i])
        return FALSE;
    }
  return TRUE;
}

function reveal()
{ for ($i=0; $i<4; $i++)
    for ($j=0; $j<10; $j++)
      $_SESSION['b'][$i*10+$j]=TRUE;
}

function swap(&$a, &$b)
{ $tmp=$a;
  $a=$b;
  $b=$tmp;
}

# restore game state
# game variables:
# $_SESSION['c'][4*10]
#    this is defined mono-dimensional because shuffle() works only with mono-dimensional arrays
# $_SESSION['b'][4*10]
#    when true that card is layed, when not defined the back of that card is displayed
# $_SESSION['st'][4]
#    the stack which has 4 cards at the beginning
# $_SESSION['t']
#    current size of $_SESSION['st']
# $_SESSION['rs'][4]
#    row suit
session_register('c', 'b', 'st', 't', 'rs');
settype($_GET['i'], 'integer');
settype($_GET['j'], 'integer');
settype($_SESSION['rs'], 'array');

# start new game
if (isset($_GET['n']))
{ session_destroy();
  header("Location: http://$_SERVER[HTTP_HOST]$_SERVER[PHP_SELF]");
  exit;
}

if (!isset($_SESSION['c']))
{ srand((float)microtime()*1000000);

   for ($i=0; $i<4; $i++)
      for ($j=0; $j<10; $j++)
         $_SESSION['c'][$i*10 + $j]=$v[$j].$s[$i];

   shuffle($_SESSION['c']);

   for ($i=0; $i<4; $i++)
   { $p=$i*10+9;
      $_SESSION['st'][$i]=$_SESSION['c'][$p];
      unset($_SESSION['c'][$p]);
   }
   $_SESSION['t']=4;
}

# reveal game
if (isset($_GET['r']) && count($_SESSION['c'])==4*10)
   reveal();

# make a move
if (isset($_GET['i']) && isset($_GET['j']) && legal_move($_GET['i'], $_GET['j']))
{ $p=$_GET['i']*10+$_GET['j'];

   if (!isset($_SESSION['c'][$p]))		# or $j==9
      $_SESSION['c'][$p]=$_SESSION['st'][--$_SESSION['t']];	# you have positioned a king, you loose that card from stack
   else
      swap($_SESSION['c'][$p], $_SESSION['st'][$_SESSION['t']-1]);  # swap cards

   # register suit for this row
   $_SESSION['rs'][$_GET['i']]=$_SESSION['c'][$p][1];
   $_SESSION['b'][$p]=TRUE;
}
?>
<html>
<head>
<title>Simple Solitaire</title>
</head>
<body link="#0000ee" vlink="#0000ee">
<div align="center">
<h1>Simple Solitaire</h1>
<?php
# redraw game
for ($i=0; $i<4; $i++)
{ echo '<nobr>';

   for ($j=0; $j<10; $j++)
   { $p=$i*10+$j;
      $l=legal_move($i, $j);

      echo ' ';

      if ($l)
         printf('<a href="%s?i=%d&j=%d">', basename($_SERVER['SCRIPT_NAME']), $i, $j);

      if (isset($_SESSION['b'][$p]))
         printf('<img src="%s/%s.gif" width="%d" height="%d" alt="%s" %s>',
            $cd, $_SESSION['c'][$p], $cw, $ch, $_SESSION['c'][$p], ($l ? 'border="2"' : 'border="0" vspace="2" hspace="2"')); 
      else if ($j!=9)
         printf('<img src="%s/b.gif" width="%d" height="%d" alt="&nbsp;b" %s>',
            $cd, $cw, $ch, ($l ? 'border="2"' : 'border="0" vspace="2" hspace="2"'));
      else
         printf('<img src="shim.gif" width="%d" height="%d" alt="--" %s>',
            $cw, $ch, ($l ? 'border="2"' : 'border="0" vspace="2" hspace="2"'));

      if ($l)
         echo '</a>';
   }

   echo "</nobr><br>\n";
}

echo  '<p>';

if ($_SESSION['t']==0)      # stack is empty
   if (count($_SESSION['b'])==4*10)
      printf('<h2>%s</h2><h3>[ <a href="%s?n=1">new game</a> ]</h3>', (won() ? 'You win' : 'You lose'), basename($_SERVER['SCRIPT_NAME']));
   else
      echo '<h2><a href="'. basename($_SERVER['SCRIPT_NAME']) .'?r=1">Click to see if you have won</a></h2>';
else for ($j=0; $j<$_SESSION['t']; $j++)
{ echo ' ';

   if ($j==$_SESSION['t']-1)
      printf('<img src="%s/%s.gif" width="%d" height="%d" alt="%s" border="0" vspace="2" hspace="2">',
         $cd, $_SESSION['st'][$j], $cw, $ch, $_SESSION['st'][$j]);
   else
      printf('<img src="%s/b.gif" width="%d" height="%d" alt="&nbsp;b" border="0" vspace="2" hspace="2">',
         $cd, $cw, $ch);
}
?>

<h6>Copyright (c) 2004 ninux - GPL<br><a href="http://queen.rett.polimi.it/~ant">http://queen.rett.polimi.it/~ant</a></h6>
</div>
</body>
</html>
